package at.reisinger.obj;

/**
 * Alle coins eines Users
 */
public class Coins {
    private int amount;

    /**
     * Erstellt ein neues Münzen Obj
     * @param coins Alle münzen des Users
     */
    public Coins(int coins) {
        this.amount = coins;
    }

    /**
     * Holt alle münzen
     * @return Alle münzen
     */
    public int getCoinAmount() {
        return this.amount;
    }

    /**
     * Fügt münzen hinzu
     * @param coins Münzen die hinzugefügt werden -> Positiv
     */
    public void addCoin(int coins){
        if(coins > 0) {
            this.amount += coins;
        }
    }

    /**
     * Entfernt münzen
     * @param coins Münzen die entfernt werden sollen, muss positiv sein
     * @return True wenn erfolgreich
     */
    public boolean removeCoin(int coins){
        if(coins < 0) {
            return false;
        }else {
            this.amount -= coins;
            return true;
        }
    }

    /**
     * Ändert den Absoluten Coin amount
     * @param coins Neue Coin anzahl, muss positiv sein
     * @return true wenn erfolgreich
     */
    public boolean changeCoinAmmount(int coins){
        if(coins < 0) {
            return false;
        }else {
            this.amount = coins;
            return true;
        }
    }
}
