package at.reisinger.obj;

import com.fasterxml.jackson.annotation.*;

import java.util.ArrayList;

/**
 * at.reisinger.obj.User & at.reisinger.Store Logik
 */
@JsonAutoDetect
public class User{
    @JsonProperty
    private String name, nachname, email, bio, image;
    //private DBConnection db;
    @JsonProperty
    private final Credentials credentials;
    @JsonProperty
    private final Coins coins;

    /*
     * Erstellt einen neuen at.reisinger.obj.User
     * @param credentials Zugangsdaten des Users
     * @param name Name des Users
     * @param nachname Nachname des Users
     * @param email Email des Users
     * @param stack Alle Karten des Users
     * @param coins Alle Münzen des Users

    @JsonCreator
    public User(@JsonProperty Credentials credentials,@JsonProperty String name,@JsonProperty String nachname,@JsonProperty String email,@JsonProperty Stack stack,@JsonProperty Coins coins) {
        this.credentials = credentials;
        this.name = name;
        this.nachname = nachname;
        this.email = email;
        this.stack = stack;
        this.coins = coins;
        //this.db = new at.reisinger.server.DBConnection();
    }
*/
    @JsonCreator
    public User(@JsonProperty Credentials credentials,@JsonProperty String name,@JsonProperty String nachname,@JsonProperty String email,@JsonProperty Coins coins, @JsonProperty String bio, @JsonProperty String image) {
        this.credentials = credentials;
        this.name = name;
        this.nachname = nachname;
        this.email = email;
        //this.stack = null;
        this.coins = coins;
        this.bio = bio;
        this.image = image;
        //this.db = new at.reisinger.server.DBConnection();
    }

    /**
     * Holt die Bio vom User
     * @return Bio des Users
     */
    @JsonGetter
    public String getBio() {
        return bio;
    }

    /**
     * Setzt die Bio vom User
     * @param bio Bio des Users
     */
    @JsonSetter
    public void setBio(String bio) {
        this.bio = bio;
    }

    /**
     * Holt das image vom user
     * @return Image vom user
     */
    @JsonGetter
    public String getImage() {
        return image;
    }

    /**
     * Setzt das image vom user
     * @param image Image vom user
     */
    @JsonSetter
    public void setImage(String image) {
        this.image = image;
    }

    /**
     * Holt die eindeutigen Logindaten des Users
     * @return Eindeutige Logindaten
     */
    @JsonGetter
    public Credentials getCredentials() {
        return credentials;
    }

    /**
     * Get Name of at.reisinger.obj.User
     * @return Name of at.reisinger.obj.User
     */
    @JsonGetter
    public String getName() {
        return this.name;
    }

    /**
     * Get Nachname of at.reisinger.obj.User
     * @return Nachname of at.reisinger.obj.User
     */
    @JsonGetter
    public String getNachname() {
        return this.nachname;
    }

    /**
     * Email of at.reisinger.obj.User
     * @return Email of at.reisinger.obj.User
     */
    @JsonGetter
    public String getEmail() {
        return this.email;
    }

    /**
     * Setzt den Namen des Users
     * @param name Neuer Name des Users
     */
    @JsonSetter
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Setzt den Nachnamen
     * @param nachname Neuer Nachname
     */
    @JsonSetter
    public void setNachname(String nachname) {
        this.nachname = nachname;
    }

    /**
     * Setzt die Email des Users
     * @param email Neue Email des Users
     */
    @JsonSetter
    public void setEmail(String email) {
        this.email = email;
    }

    //at.reisinger.Store Methoden

    /**
     * Kauft ein at.reisinger.obj.Package
     * @param mypackage at.reisinger.obj.Package welches gekauft werden soll
     * @return Alle Karten des neuen at.reisinger.obj.Package
     */
    public ArrayList<Card> buyPackage(Package mypackage){
        this.coins.removeCoin(mypackage.getPrice());
        return mypackage.getCards();
    }
}
