import at.reisinger.obj.*;
import at.reisinger.enums.CardType;
import at.reisinger.enums.ElementTyp;
import at.reisinger.obj.Package;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.Objects;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;


public class UserTest {
    private TradingDeal tradingDeal;
    private User user;
    private Package myPackage;

    @BeforeEach
    void setUp() {
        //at.reisinger.Stack
        Card card = new Card("Name", 10, ElementTyp.WATER, CardType.MONSTER);
        Card newCard = new Card("NameNew", 10, ElementTyp.WATER, CardType.SPELL);
        ArrayList<Card> cardsArrayList = new ArrayList<>();
        ArrayList<Card> cardsArrayList2 = new ArrayList<>();
        ArrayList<Card> cardsArrayList3 = new ArrayList<>();
        cardsArrayList.add(card);
        cardsArrayList2.add(newCard);
        Cards cards = new Cards(cardsArrayList);
        Cards newCards = new Cards(cardsArrayList2);
        Cards nochNewCards = new Cards(cardsArrayList3);
        //at.reisinger.obj.Package
        myPackage = new Package(cards, "Name", 100);

        //at.reisinger.obj.Coins
        Coins coins = new Coins(10);
        //at.reisinger.obj.User
        Credentials credentials = new Credentials("username", "pw");
        user = new User(credentials, "name", "nachname", "email", coins, "BIO", "IMAGE");
    }
    @Test
    public void test_getName() {
        String result = user.getName();
        assertEquals(result, "name");
    }
    @Test
    public void test_getNachname() {
        String result = user.getNachname();
        assertEquals(result, "nachname");
    }
    @Test
    public void test_getEmail() {
        String result = user.getEmail();
        assertEquals(result, "email");
    }

    @Test
    public void test_setName() {
        String newstring = "new";
        user.setName(newstring);
        String result = user.getName();
        assertEquals(newstring, result);
    }
    @Test
    public void test_setNachname() {
        String newstring = "new";
        user.setNachname(newstring);
        String result = user.getNachname();
        assertEquals(newstring, result);
    }
    @Test
    public void test_setEmail() {
        String newstring = "new";
        user.setEmail(newstring);
        String result = user.getEmail();
        assertEquals(newstring, result);
    }
    @Test
    public void test_buyPackage(){
        Cards cards;
            cards = new Cards(user.buyPackage(myPackage));
        assertTrue(Objects.requireNonNull(cards).equals(new Cards(myPackage.getCards())));
    }
}
